unit hiExportHTML;

interface

uses Kol,windows,Share,Debug;

const TR     = '  <tr>';
      TR_END = '  </tr>';
      TD_END = '</td>';

      TD_HROWS   = '    <td class="ThRows">';
      TD_RROWS_L = '    <td class="TrRows_l">';
      TD_RROWS_R = '    <td class="TrRows_r">';
      TD_RROWS_C = '    <td class="TrRows_c">';

      TD_RODD_L  = '    <td class="TrOdd_l">';
      TD_RODD_R  = '    <td class="TrOdd_r">';
      TD_RODD_C  = '    <td class="TrOdd_c">';

      HTML_END = '</Table>' + #13#10 + '</BODY>' + #13#10 + '</HTML>';

      LVM_FIRST        = $1000;
      LVM_GETHEADER    = LVM_FIRST + 31;
      HDM_GETITEMCOUNT = HDM_FIRST + 0;
      HDM_GETITEM      = HDM_FIRST + 3;
      HDI_TEXT         = $0002;
      HDF_STRING       = $4000;
      LVM_GETITEMCOUNT = LVM_FIRST + 4;
      LVM_GETITEMTEXT  = LVM_FIRST + 45;

type
  HD_ITEM = packed record
    Mask: Cardinal;
    cxy: Integer;
    pszText: PAnsiChar;
    hbm: HBITMAP;
    cchTextMax: Integer;
    fmt: Integer;
    lParam: LPARAM;
    iImage: Integer;
    iOrder: Integer;
  end;

type
  LV_ITEM = packed record
    mask: UINT;
    iItem: Integer;
    iSubItem: Integer;
    state: UINT;
    stateMask: UINT;
    pszText: PAnsiChar;
    cchTextMax: Integer;
    iImage: Integer;
    lParam: LPARAM;
    iIndent: Integer;
  end;


type
  TStyle = record
    backgroundcolor: string;
    color: string;
    link: string;
    visited: string;
    active: string;
    Title: string;
  end;


type
  THIExportHTML = class(TDebug)
   private

   public
    fStrHtml:string;
    fTable:TStyle;
    fhRows:TStyle;
    frRows:TStyle;
    frOdd:TStyle;
    fHandle:Longint;
    fColCount:integer;

    _prop_Style:integer;

    _data_Title:THI_Event;
    _data_Handle:THI_Event;
    _event_onExportHTML:THI_Event;
    _event_onCount:THI_Event;
    _event_onProgress:THI_Event;

    procedure StartHtml;
    procedure SetStyle;
    function AddColumn(ALVHandle:HWND): boolean;
    function AddRow(ALVHandle:HWND): boolean;

    procedure _work_doExportHTML(var _Data:TData; Index:word);
    procedure _work_doStyle(var _Data:TData; Index:word);

  end;

implementation

function ListView_GetItemCount(hWnd: HWND): Integer;
begin
  Result := SendMessage(hWnd, LVM_GETITEMCOUNT, 0, 0);
end;

function ListView_GetHeader(hwnd: HWND): HWND;
begin
  Result := SendMessage(hwnd, LVM_GETHEADER, 0, 0);
end;

function Header_GetItemCount(Header: HWnd): Integer;
begin
  Result := SendMessage(Header, HDM_GETITEMCOUNT, 0, 0);
end;

function Header_GetItem(Header: HWnd; Index: Integer; var Item: HD_ITEM): Bool;
begin
  Result := Bool( SendMessage(Header, HDM_GETITEM, Index, Longint(@Item)) );
end;

function IsDateTime(s: string): Boolean;
var i,h,g,ln: integer;
begin
  Result := False;
  h := 0; g := 0;
  ln := Length(s);
  if ln = 0 then exit;
  for i := 1 to ln do
    begin
      case Char(s[i]) of
        '0'..'9',' ':;
        ':': inc(h);
        '.','-': inc(g);
        else begin Result := False; Exit; end;
      end;
    end;
  if (h = 1) or (h = 2) then Result := True
    else
  if g = 2 then Result := True;
end;


function CheckData(s:string):boolean;
var i,j,ln: integer;
begin
  Result := False;
  j := 0;
  ln := Length(s);
  if ln = 0 then exit;
  if ln > 10 then ln := 10;
  for i := 1 to ln do
    begin
      case Char(s[i]) of
        '0'..'9',{'.',}',',' ','+','-' : inc(j);
        else begin dec(j); Result := False; Exit; end;
      end;
    end;
  if j = ln then Result := True
    else Result := False;
end;


function THIExportHTML.AddRow(ALVHandle:HWND): boolean;
const cchTextMax=255;
var  LVItemCount: Integer;
     i,j: Integer;
     LVItem: LV_ITEM;
     pszText: string[255];
     strTmp:string;

begin
  Result := False;
  if ALVHandle = 0 then Exit;
  LVItemCount := ListView_GetItemCount(ALVHandle);
  if LVItemCount = 0 then Exit;


  ZeroMemory(@LVItem, SizeOf(LV_ITEM));
  LVItem.mask := LVIF_TEXT;
  LVItem.pszText := @pszText;
  LVItem.cchTextMax := cchTextMax;
  LVItem.iSubItem := 0;

  if LVItemCount = 0 then exit;

    for i := 0 to LVItemCount - 1 do
    begin
    _hi_onEvent(_event_onProgress,i);
    fStrHtml := fStrHtml + TR + #13#10;
        for j := 0 to fColCount - 1 do
        begin
          LVItem.iSubItem := j;
          SendMessage(ALVHandle, LVM_GETITEMTEXT, i, Longint(@LVItem));
          strTmp := LVItem.pszText;
          if strTmp = '' then strTmp := '&nbsp';
          if  CheckData(strTmp) then begin
            if (i and 1) = 0 then
              fStrHtml := fStrHtml + TD_RODD_R + strTmp + TD_END + #13#10
            else
              fStrHtml := fStrHtml + TD_RROWS_R + strTmp + TD_END + #13#10;
          end else if IsDateTime(strTmp) then begin
            if (i and 1) = 0 then
              fStrHtml := fStrHtml + TD_RODD_C + strTmp + TD_END + #13#10
            else
              fStrHtml := fStrHtml + TD_RROWS_C + strTmp + TD_END + #13#10;
          end else begin
            if (i and 1) = 0 then
              fStrHtml := fStrHtml + TD_RODD_L + strTmp + TD_END + #13#10
            else
              fStrHtml := fStrHtml + TD_RROWS_L + strTmp + TD_END + #13#10;
          end;
        end;
       fStrHtml := fStrHtml + TR_End + #13#10;
    end;
  _hi_onEvent(_event_onProgress,0);
  Result := True;
end;


function THIExportHTML.AddColumn(ALVHandle:HWND): boolean;
const cchTextMax=148;
var i: Integer;
    lvHeader: HWND;
    lvHeaderItem: HD_ITEM;
    pszText: string[148];
begin
  Result := False;
  lvHeader := ListView_GetHeader(ALVHandle);
  fColCount := Header_GetItemCount(lvHeader);
  if fColCount = 0 then Exit;

  ZeroMemory(@lvHeaderItem, SizeOf(HD_ITEM));

  lvHeaderItem.mask := HDI_TEXT;
  lvHeaderItem.fmt := HDF_STRING;
  lvHeaderItem.pszText := @pszText;
  lvHeaderItem.cchTextMax := cchTextMax;

  fStrHtml := fStrHtml + TR + #13#10;

  for i := 0 to fColCount-1 do
  begin
    Header_GetItem(lvHeader, i, lvHeaderItem);
    fStrHtml := fStrHtml + TD_HROWS + lvHeaderItem.pszText + TD_END + #13#10;
  end;
  fStrHtml := fStrHtml + TR_END + #13#10;
  Result := True;
end;


procedure THIExportHTML.StartHtml;
begin
  fStrHtml := '<HTML>' + #13#10 +
  '<HEAD>' + #13#10 +
  '<meta charset="WINDOWS-1251">' + #13#10 +
  ' <Title>' + fTable.Title + '</Title>' + #13#10 +
  '<Style type="text/css">' + #13#10 +
  '  BODY { background:' + fTable.backgroundcolor + 'color: ' + fTable.color  + #13#10 +
  '       font-family: Arial;' + #13#10 +
  '  }' + #13#10 +
  '  A:link' + fTable.link + #13#10 +
  '  A:visited' + fTable.visited + #13#10 +
  '  A:active' +  fTable.active + #13#10 +
  '  .ThRows {' + #13#10 +
  '            background-color: ' + fhRows.backgroundcolor + #13#10 +
  '            color: ' + fhRows.color + #13#10 +
  '            font-weight: bold; text-align: center;' + #13#10 +
  '            font-family: Arial;' + #13#10 +
  '  }' + #13#10 +
  '  .TrRows_l {' + #13#10 +
  '            background-color: ' + frRows.backgroundcolor + #13#10 +
  '            color: ' + frRows.color + #13#10 +
  '            font-family: Arial;' + #13#10 +
  '            text-align: Left;' + #13#10 +
  '  }' + #13#10 +
  '  .TrOdd_l  {' + #13#10 +
  '            background-color: ' + frOdd.backgroundcolor + #13#10 +
  '            color: ' + frOdd.color + #13#10 +
  '            font-family: Arial;' + #13#10 +
  '            text-align: Left;' + #13#10 +
  '  }' + #13#10 +
  '  .TrRows_r {' + #13#10 +
  '            background-color: ' + frRows.backgroundcolor + #13#10 +
  '            color: ' + frRows.color + #13#10 +
  '            font-family: Arial;' + #13#10 +
  '            text-align: Right;' + #13#10 +
  '  }' + #13#10 +
  '  .TrOdd_r  {' + #13#10 +
  '            background-color: ' + frOdd.backgroundcolor + #13#10 +
  '            color: ' + frOdd.color + #13#10 +
  '            font-family: Arial;' + #13#10 +
  '            text-align: Right;' + #13#10 +
  '  }' + #13#10 +
  '  .TrRows_c {' + #13#10 +
  '            background-color: ' + frRows.backgroundcolor + #13#10 +
  '            color: ' + frRows.color + #13#10 +
  '            font-family: Arial;' + #13#10 +
  '            text-align: Center;' + #13#10 +
  '  }' + #13#10 +
  '  .TrOdd_c  {' + #13#10 +
  '            background-color: ' + frOdd.backgroundcolor + #13#10 +
  '            color: ' + frOdd.color + #13#10 +
  '            font-family: Arial;' + #13#10 +
  '            text-align: Center;' + #13#10 +
  '  }' + #13#10 +
  '</STYLE>' + #13#10 +
  '</HEAD>' + #13#10 +
  '<BODY>' + #13#10 +
  '<Table Border="1" Cellpadding="4" Cellspacing="1">' + #13#10;

end;


procedure THIExportHTML.SetStyle;
begin
  case _prop_Style of
    0: begin
         fTable.backgroundcolor := '#FFFFFF;';
         fTable.color := '#000000;';
         fTable.link := ' { color: #FF0000 }';
         fTable.visited := ' { color: #800080 }';
         fTable.active := ' { color: #0000FF }';
         fhRows.backgroundcolor := '#000000;';
         fhRows.color := '#FFFFFF;';
         frRows.backgroundcolor := '#FFFFFF;';
         frRows.color := '#000000;';
         frOdd.backgroundcolor := '#F3F3F3;';
         frOdd.color := '#000000;';
       end;
    1: begin
         fTable.backgroundcolor := '#333399;';
         fTable.color := '#FFFFFF;';
         fTable.link := ' { color: #69EF7D }';
         fTable.visited := ' { color: #FF00FF }';
         fTable.active := ' { color: #00FF00 }';
         fhRows.backgroundcolor := '#FF0000;';
         fhRows.color := '#FFFFFF;';
         frRows.backgroundcolor := '#007AEC;';
         frRows.color := '#FFFFFF;';
         frOdd.backgroundcolor := '#006BCE;';
         frOdd.color := '#FFFFFF;';
       end;
    2: begin
         fTable.backgroundcolor := '#339966;';
         fTable.color := '#FFFFFF;';
         fTable.link := ' { color: #0066CC }';
         fTable.visited := ' { color: #923FC1 }';
         fTable.active := ' { color: #0000FF }';
         fhRows.backgroundcolor := '#CC0033;';
         fhRows.color := '#FFFFFF;';
         frRows.backgroundcolor := '#FFFFFF;';
         frRows.color := '#000000;';
         frOdd.backgroundcolor := '#FAF100;';
         frOdd.color := '#000000;';
       end;
    3: begin
         fTable.backgroundcolor := '#FFFFFF;';
         fTable.color := '#000000;';
         fTable.link := ' { color: #FF0000 }';
         fTable.visited := ' { color: #800080 }';
         fTable.active := ' { color: #0000FF }';
         fhRows.backgroundcolor := '#808080;';
         fhRows.color := '#FFFFFF;';
         frRows.backgroundcolor := '#FFFFFF;';
         frRows.color := '#000000;';
         frOdd.backgroundcolor := '#EEEEEE;';
         frOdd.color := '#000000;';
       end;
    4: begin
         fTable.backgroundcolor := '#FFFFFF;';
         fTable.color := '#000000;';
         fTable.link := ' { color: #FF0000 }';
         fTable.visited := ' { color: #800080 }';
         fTable.active := ' { color: #0000FF }';
         fhRows.backgroundcolor := '#CEC6B5;';
         fhRows.color := '#000000;';
         frRows.backgroundcolor := '#DEE7DE;';
         frRows.color := '#000000;';
         frOdd.backgroundcolor := '#FFFBF0;';
         frOdd.color := '#000000;';
       end;
    5: begin
         fTable.backgroundcolor := '#317676;';
         fTable.color := '#FFFFFF;';
         fTable.link := ' { color: #FFE760 }';
         fTable.visited := ' { color: #CCCC39 }';
         fTable.active := ' { color: #FFFF00 }';
         fhRows.backgroundcolor := '#3A9393;';
         fhRows.color := '#FFFFFF;';
         frRows.backgroundcolor := '#276262;';
         frRows.color := '#FFE760;';
         frOdd.backgroundcolor := '#367800;';
         frOdd.color := '#FFE760;';
       end;
    6: begin
         fTable.backgroundcolor := '#FFFFFF;';
         fTable.color := '#5F605F;';
         fTable.link := ' { color: #FF0000 }';
         fTable.visited := ' { color: #800080 }';
         fTable.active := ' { color: #0000FF }';
         fhRows.backgroundcolor := '#CFC890;';
         fhRows.color := '#000000;';
         frRows.backgroundcolor := '#FFFFFF;';
         frRows.color := '#5F605F;';
         frOdd.backgroundcolor := '#FFFFCF;';
         frOdd.color := '#5F605F;';
       end;
    7: begin
         fTable.backgroundcolor := '#FFFFFF;';
         fTable.color := '#000000;';
         fTable.link := ' { color: #FF0000 }';
         fTable.visited := ' { color: #800080 }';
         fTable.active := ' { color: #0000FF }';
         fhRows.backgroundcolor := '#068FE6;';
         fhRows.color := '#FFFFFF;';
         frRows.backgroundcolor := '#FFFFFF;';
         frRows.color := '#000000;';
         frOdd.backgroundcolor := '#FFFCD9;';
         frOdd.color := '#000000;';
       end;
    8: begin
         fTable.backgroundcolor := '#FFFFFF;';
         fTable.color := '#004080;';
         fTable.link := ' { color: #FF0000 }';
         fTable.visited := ' { color: #800080 }';
         fTable.active := ' { color: #0000FF }';
         fhRows.backgroundcolor := '#336699;';
         fhRows.color := '#FFFFFF;';
         frRows.backgroundcolor := '#FFFFFF;';
         frRows.color := '#000000;';
         frOdd.backgroundcolor := '#FFFFCF;';
         frOdd.color := '#000000;';
       end;
  end;
end;


procedure THIExportHTML._work_doExportHTML;
var LVItemCount:integer;
begin
  fHandle := ReadInteger(_Data, _data_Handle, 0);
  if fHandle = 0 then Exit;

  fTable.Title := ReadString(_Data,_data_Title);
  LVItemCount := ListView_GetItemCount(fHandle);
  _hi_onEvent(_event_onCount,LVItemCount);

  SetStyle;
  StartHtml;
  if not AddColumn(fHandle) then Exit;
  if not AddRow(fHandle) then Exit;

  fStrHtml := fStrHtml + HTML_END;
  _hi_onEvent(_event_onExportHTML,fStrHtml);
  fStrHtml := '';
end;

procedure THIExportHTML._work_doStyle;
begin
  _prop_Style := ToInteger(_Data);
end;

end.
